function div(x,y) { return Math.floor(x/y); }

var pos = [];
for (var i=0; i<64; i++) { var p = pos[i] = {p:i, x:i%8, y:Math.floor(i/8)}; p.xi=p.x; p.yi=p.y; }
function gettrans(p) { return "translate("+20*p.x+","+20*(1+p.y)+")"; }
function getx(p) { return 210+8*p.p; }
//var hue = d3.scale.linear().domain([0,63]).range([-60,240]);
//function color(i) { return "hsl("+hue(8*i.xi+i.yi)+",30%,60%)"; }
function color(i) { return d3.interpolateYlGnBu(0.9-(8*i.xi+i.yi)/90); }

var svg = d3.select("#svg")
    .append("g").attr("transform", "scale(2)");
var bits = svg.selectAll("bit")
    .data(pos);
var brec = bits
    .enter().append("g")
    .attr("transform", gettrans);
var bliny = 30;
var blin = svg.selectAll("bit")
    .data(pos)
    .enter().append("rect")
    .attr({x:getx, y:bliny, width:8, height:8})
    .attr("fill", color);

brec.append("rect")
    .attr({x:0, y:0, width:20, height:20})
    .attr("fill", color);
brec.append("text")
    .attr({x:4, y:18, "font-size":"20", opacity:"70%"})
    .text(i => (i.p%5)%2 == div(i.p,3)%2 ? 1 : 0);

var inds = [];
function addind() { inds.push(pos.map(p=>p.p)); }
function filter(hex, pos) { return div(parseInt(hex[hex.length-1-div(pos,4)],16), Math.pow(2,pos%4))%2; }
function getFilter(hex) { return p => filter(hex,p.p); }
function transpose_part(filter, shift, diff, dur) {
    addind();
    svg.selectAll("bit")
        .data(pos)
        .enter().append("rect")
        .attr({x:getx, y:bliny, width:8, height:8})
        .attr("fill", color);
    function delayf(p) { return 700 + diff*(p.x%(2*shift)<shift); }
    brec.filter(getFilter(filter))
        .each(function() {this.parentNode.appendChild(this);})
        .transition().delay(delayf).duration(dur)
        .attr("transform", function(p) {
            var s = shift; if (p.x%(2*s) >= s) s *= -1;
            p.x += s; p.y -= s;
            return gettrans(p);
        });
    bliny += 43;
    blin.transition().duration(700)
        .attr("y", bliny);
    var blinysave = bliny;
    blin.filter(getFilter(filter))
        .each(function() {this.parentNode.appendChild(this);})
        .transition().delay(delayf).duration(dur)
        .attrTween("y", p => t => blinysave + 5*(p.x%(2*shift)<shift?1:-1)*(0.7+shift)*Math.sin(Math.PI*t))
        .attr("x", function (p) { p.p = 8*p.y + p.x; return getx(p); });
}

function showarrows() {
    addind();
    svg.selectAll("arrowrow")
        .data([0,1,2]).enter().append("g")
        .attr("transform", i=>"translate(0,"+(30+43*i)+")")
        .selectAll("arrow")
        .data(i => inds[i].map((e,j)=>[e, inds[i+1][j]]))
        .enter().append("line")
        .attr({stroke:"black", x1:a=>214+8*a[0], y1:8, x2:a=>214+8*a[1], y2:43});
}


var step = 0;
document.onclick = function() {
    switch (step++) {
        case 0: transpose_part("0f0f0f0ff0f0f0f0", 4, 800, 2600); break;
        case 1: transpose_part("3333cccc3333cccc", 2, 200, 1500); break;
        case 2: transpose_part("55aa55aa55aa55aa", 1, 100, 1200); break;
        case 3: showarrows(); break;
    }
}
